;****************************************************************************
;****************************************************************************
;*
;* c64memory.i
;*
;****************************************************************************
;****************************************************************************





%ifndef C64MEMORY_I
%define C64MEMORY_I

%include "defines.i"
%include "macros.i"
%include "ec64types.i"

;****************************************************************************
;* Exported Symbols *********************************************************
;****************************************************************************
%ifdef C64MEMORY_N
global c64memory_initialize
global c64memory_exit
global c64memory_instance_initialize
global c64memory_instance_exit
global c64memory_reset_hard
global c64memory_reset_soft
global c64memory_read_opcode
global c64memory_read_stack
global c64memory_read_data
global c64memory_write_stack
global c64memory_write_data
global c64memory_load_rom_basic
global c64memory_load_rom_character
global c64memory_load_rom_kernel
%else
extern c64memory_initialize
extern c64memory_exit
extern c64memory_instance_initialize
extern c64memory_instance_exit
extern c64memory_reset_hard
extern c64memory_reset_soft
extern c64memory_read_opcode
extern c64memory_read_stack
extern c64memory_read_data
extern c64memory_write_stack
extern c64memory_write_data
extern c64memory_load_rom_basic
extern c64memory_load_rom_character
extern c64memory_load_rom_kernel
%endif



;****************************************************************************
;* Module Data **************************************************************
;****************************************************************************
					struc	tc64memory
					alignb	4
d__c64memory_modulid:			resd	1
d__c64memory_state:			resd	1
b__c64memory_cpu6510_ddr:		resb	1
b__c64memory_cpu6510_io:		resb	1
b__c64memory_cpu6510_data:		resb	1
b__c64memory_cpu6510_mask:		resb	1
d__c64memory_read_opcode_low_limit:	resd	1
d__c64memory_read_opcode_high_limit:	resd	1
ab__c64memory_ram:			resb	010000h
ab__c64memory_color_ram:		resb	000400h
ab__c64memory_basic_rom:		resb	002000h
ab__c64memory_character_rom:		resb	001000h
ab__c64memory_kernel_rom:		resb	002000h
					endstruc



;****************************************************************************
;* assign's & define's ******************************************************
;****************************************************************************
%define C64MEMORY_MODULID			esi + tmemory__c64 + d__c64memory_modulid
%define C64MEMORY_STATE				esi + tmemory__c64 + d__c64memory_state
%define C64MEMORY_CPU6510_DDR			esi + tmemory__c64 + b__c64memory_cpu6510_ddr
%define C64MEMORY_CPU6510_IO			esi + tmemory__c64 + b__c64memory_cpu6510_io
%define C64MEMORY_CPU6510_DATA			esi + tmemory__c64 + b__c64memory_cpu6510_data
%define C64MEMORY_CPU6510_MASK			esi + tmemory__c64 + b__c64memory_cpu6510_mask
%define C64MEMORY_READ_OPCODE_LOW_LIMIT		esi + tmemory__c64 + d__c64memory_read_opcode_low_limit
%define C64MEMORY_READ_OPCODE_HIGH_LIMIT	esi + tmemory__c64 + d__c64memory_read_opcode_high_limit
%define C64MEMORY_RAM				esi + tmemory__c64 + ab__c64memory_ram
%define C64MEMORY_COLOR_RAM			esi + tmemory__c64 + ab__c64memory_color_ram
%define C64MEMORY_BASIC_ROM			esi + tmemory__c64 + ab__c64memory_basic_rom
%define C64MEMORY_CHARACTER_ROM			esi + tmemory__c64 + ab__c64memory_character_rom
%define C64MEMORY_KERNEL_ROM			esi + tmemory__c64 + ab__c64memory_kernel_rom



%assign C64MEMORY_STACK_LIMIT_EXCEEDED		000000001h



;****************************************************************************
;* Macro's ******************************************************************
;****************************************************************************
%macro C64MEMORY_CALL_INITIALIZE 0
			call	c64memory_initialize
%endmacro



%macro C64MEMORY_CALL_INSTANCE_INITIALIZE 1
			call	c64memory_instance_initialize
			mov	dword eax, %1
			mov	dword [C64MEMORY_MODULID], eax
%endmacro



%macro C64MEMORY_CALL_RESET_HARD 0
			call	c64memory_reset_hard
%endmacro



%macro C64MEMORY_CALL_RESET_SOFT 0
			call	c64memory_reset_soft
%endmacro



%endif
;******************************************************** ec64@unusedino.de *

