;****************************************************************************
;****************************************************************************
;*
;* link.n
;*
;****************************************************************************
;****************************************************************************





%define LINK_N
%include "link.i"
%include "core.i"
%include "c64link.i"
%include "c1541link.i"



;****************************************************************************
;* local data ***************************************************************
;****************************************************************************
section .data
flag__atn_cleared:	db	0



;****************************************************************************
;* link_nothing *************************************************************
;****************************************************************************
section .text
link_nothing:
			ret



;****************************************************************************
;* serial_bus ***************************************************************
;****************************************************************************
section .text
link_serial_bus:
			push	dword edi
			push	dword esi
			mov	dword esi, tc64__1
			mov	byte  al, [C64LINK_SERIAL_BUS]
			mov	dword esi, tc1541__1
			mov	byte  bl, [C1541LINK_SERIAL_BUS]
			test	byte  bl, 001h
			jz	.skip_set
			mov	byte  [flag__atn_cleared], 1
.skip_set:		test	byte  al, 001h
			jz	.clear
			test	byte  [flag__atn_cleared], NOT8
			jnz	.no_data_influence
			or	byte  al, 4
			jmp	.no_data_influence
.clear:			mov	byte  [flag__atn_cleared], 0
.no_data_influence:	and	byte  bl, 0feh
			or	byte  al, bl
			mov	dword edi, (tc64__1 + tcia6526__c64_2)
			mov	byte  bl, al
			xor	byte  al, NOT8
			shl	byte  al, 5
			and	byte  al, 0c0h
			or	byte  al, 03fh	;unused bits in SIGNAL_PRA/B must be 1
			call	cia6526_signal_pra
			mov	byte  al, bl
			mov	dword edi, (tc1541__1 + tvia6522__c1541_1)
			and	byte  al, 001h
			call	via6522_signal_ca1
			xor	byte  al, al
			test	byte  bl, 1
			jz	.no_atn
			or	byte  al, 080h
.no_atn:		test	byte  bl, 2
			jz	.no_clk
			or	byte  al, 004h
.no_clk:		test	byte  bl, 4
			jz	.no_data
			or	byte  al, 001h
.no_data:		call	via6522_signal_pb
			pop	dword esi
			pop	dword edi
			ret
;******************************************************** ec64@unusedino.de *

