;****************************************************************************
;****************************************************************************
;*
;* sid6581.i
;*
;****************************************************************************
;****************************************************************************





%ifndef SID6581_I
%define SID6581_I

%include "defines.i"
%include "macros.i"
%include "ec64types.i"

;****************************************************************************
;* Exported Symbols *********************************************************
;****************************************************************************
%ifdef SID6581_N
global sid6581_initialize
global sid6581_exit
global sid6581_instance_initialize
global sid6581_instance_exit
global sid6581_buffer_initialize
global sid6581_reset_hard
global sid6581_reset_soft
global sid6581_read
global sid6581_write
global sid6581_cycle
%else
extern sid6581_initialize
extern sid6581_exit
extern sid6581_instance_initialize
extern sid6581_instance_exit
extern sid6581_buffer_initialize
extern sid6581_reset_hard
extern sid6581_reset_soft
extern sid6581_read
extern sid6581_write
extern sid6581_cycle
%endif



;****************************************************************************
;* Module Data **************************************************************
;****************************************************************************
					struc	tsidvoice
					alignb	4
q__sidvoice_timestamp_oscillator:	resd	2
q__sidvoice_timestamp_envelope:		resd	2
d__sidvoice_remaining_offset:		resd	1
d__sidvoice_remaining_cycles:		resd	1
d__sidvoice_noise_register:		resd	1
d__sidvoice_frequency:			resd	1
d__sidvoice_pulse_width:		resd	1
b__sidvoice_attack:			resb	1
b__sidvoice_decay:			resb	1
b__sidvoice_sustain:			resb	1
b__sidvoice_release:			resb	1
d__sidvoice_control:			resd	1
					endstruc



					struc	tsid6581
					alignb	4
d__sid6581_modulid:			resd	1
d__sid6581_sample_rate:			resd	1
p__sid6581_buffer:			resd	1
d__sid6581_buffer_size:			resd	1
p__sid6581_buffer_offset:		resd	1
d__sid6581_sample_counter:		resd	1
q__sid6581_timestamp:			resd	2
tsidvoice__sid6581_voice1:		resb	tsidvoice_size
tsidvoice__sid6581_voice2:		resb	tsidvoice_size
tsidvoice__sid6581_voice3:		resb	tsidvoice_size
d__sid6581_volume:			resd	1
					endstruc



;****************************************************************************
;* assign's & defines's *****************************************************
;****************************************************************************
%define SIDVOICE_TIMESTAMP_OSCILLATOR	q__sidvoice_timestamp_oscillator
%define SIDVOICE_TIMESTAMP_ENVELOPE	q__sidvoice_timestamp_envelope
%define SIDVOICE_REMAINING_OFFSET	d__sidvoice_remaining_offset
%define SIDVOICE_REMAINING_CYCLES	d__sidvoice_remaining_cycles
%define SIDVOICE_NOISE_REGISTER		d__sidvoice_noise_register
%define SIDVOICE_FREQUENCY		d__sidvoice_frequency
%define SIDVOICE_PULSE_WIDTH		d__sidvoice_pulse_width
%define SIDVOICE_ATTACK			b__sidvoice_attack
%define SIDVOICE_DECAY			b__sidvoice_decay
%define SIDVOICE_SUSTAIN		b__sidvoice_sustain
%define SIDVOICE_RELEASE		b__sidvoice_release
%define SIDVOICE_CONTROL		d__sidvoice_control
%define SIDVOICE_SIZE			tsidvoice_size

%define SID6581_MODULID			esi + tsid6581__c64 + d__sid6581_modulid
%define SID6581_SAMPLE_RATE		esi + tsid6581__c64 + d__sid6581_sample_rate
%define SID6581_BUFFER			esi + tsid6581__c64 + p__sid6581_buffer
%define SID6581_BUFFER_SIZE		esi + tsid6581__c64 + d__sid6581_buffer_size
%define SID6581_BUFFER_OFFSET		esi + tsid6581__c64 + p__sid6581_buffer_offset
%define SID6581_SAMPLE_COUNTER		esi + tsid6581__c64 + d__sid6581_sample_counter
%define SID6581_TIMESTAMP		esi + tsid6581__c64 + q__sid6581_timestamp
%define SID6581_VOICE1			esi + tsid6581__c64 + tsidvoice__sid6581_voice1
%define SID6581_VOICE2			esi + tsid6581__c64 + tsidvoice__sid6581_voice2
%define SID6581_VOICE3			esi + tsid6581__c64 + tsidvoice__sid6581_voice3
%define SID6581_VOLUME			esi + tsid6581__c64 + d__sid6581_volume



;****************************************************************************
;* Macro's ******************************************************************
;****************************************************************************
%macro SID6581_CALL_INITIALIZE 0
			call	sid6581_initialize
%endmacro



%macro SID6581_CALL_INSTANCE_INITIALIZE 1
			call	sid6581_instance_initialize
			mov	dword eax, %1
			mov	dword [SID6581_MODULID], eax
%endmacro



%macro SID6581_CALL_RESET_HARD 0
			call	sid6581_reset_hard
%endmacro



%macro SID6581_CALL_RESET_SOFT 0
			call	sid6581_reset_soft
%endmacro



%macro SID6581_CALL_CYCLE 0
			mov	dword eax, [SID6581_SAMPLE_COUNTER]
			cmp	dword eax, C64_CLOCK
			jb	%%skip_cycle
			sub	dword eax, C64_CLOCK
			push	dword eax
			call	sid6581_cycle
			pop	dword eax
%%skip_cycle:		add	dword eax, [SID6581_SAMPLE_RATE]
			mov	dword [SID6581_SAMPLE_COUNTER], eax
%endmacro



%endif
;******************************************************** ec64@unusedino.de *

