;****************************************************************************
;****************************************************************************
;*
;* vic6569.i
;*
;****************************************************************************
;****************************************************************************





%ifndef VIC6569_I
%define VIC6569_I

%include "defines.i"
%include "macros.i"
%include "ec64types.i"

;%define VIC6569_LOG_HACK

;****************************************************************************
;* Exported Symbols *********************************************************
;****************************************************************************
%ifdef VIC6569_N
global vic6569_initialize
global vic6569_exit
global vic6569_instance_initialize
global vic6569_instance_exit
global vic6569_screen_initialize
global vic6569_reset_hard
global vic6569_reset_soft
global vic6569_signal_high_bits
global vic6569_read
global vic6569_write
%ifdef VIC6569_LOG_HACK
global vic6569_log
%endif ;VIC6569_LOG_HACK
%else
extern vic6569_initialize
extern vic6569_exit
extern vic6569_instance_initialize
extern vic6569_instance_exit
extern vic6569_screen_initialize
extern vic6569_reset_hard
extern vic6569_reset_soft
extern vic6569_signal_high_bits
extern vic6569_read
extern vic6569_write
%ifdef VIC6569_LOG_HACK
extern vic6569_log
%endif ;VIC6569_LOG_HACK
%endif



;****************************************************************************
;* Module Data **************************************************************
;****************************************************************************
%assign VIC6569_REGISTERS_SIZE		48	;47 + 1 for dword alignment
%assign VIC6569_LINES_PER_FRAME		312
%assign VIC6569_CYCLES_PER_LINE		63
%assign VIC6569_CHANGE_LOG_SIZE		19



					struc	tvicline
					alignb	4
ab__vicline_registers:			resb	VIC6569_REGISTERS_SIZE
ad__vicline_change_log:			resd	VIC6569_CHANGE_LOG_SIZE
ab__vicline_color_ram_cache:		resb	41
ab__vicline_video_cache:		resb	41
ab__vicline_data_cache:			resb	41
b__vicline_sprite_dma_mask_last:	resb	1
d__vicline_state:			resd	1
d__vicline_line_counter:		resd	1
ab__vicline_sprite_cache:		resd	8
					endstruc



					struc	tvicbase
					alignb	4
d__vicbase_state:			resd	1
p__vicbase_execute_cycle:		resd	1
p__vicbase_execute_cycle_switch:	resd	1
d__vicbase_cycle_counter:		resd	1
b__vicbase_ecm_address_mask:		resb	1
b__vicbase_extra_video_byte:		resb	1
b__vicbase_dma_delay_counter:		resb	1
b__vicbase_sprite_dma_mask:		resb	1
b__vicbase_sprite_dma_mask_base:	resb	1
b__vicbase_sprite_dma_mask_last:	resb	1
b__vicbase_sprite_y_expand_mask:	resb	1
					resb	1
d__vicbase_sprite_dma_cycles:		resd	1
d__vicbase_sprite_dma_cycles_base:	resd	1
d__vicbase_sprite_cache_offset:		resd	1
ab__vicbase_sprite_counters:		resb	8
d__vicbase_video_address:		resd	1
d__vicbase_data_address:		resd	1
d__vicbase_video_counter:		resd	1
d__vicbase_row_counter:			resd	1
d__vicbase_video_cache_offset:		resd	1
d__vicbase_change_log_offset:		resd	1
q__vicbase_line_timestamp:		resd	2
d__vicbase_line_counter:		resd	1
d__vicbase_line_latch:			resd	1
d__vicbase_border_left:			resd	1
d__vicbase_border_right:		resd	1
d__vicbase_border_top:			resd	1
d__vicbase_border_buttom:		resd	1
d__vicbase_frame_offset_last:		resd	1
d__vicbase_frame_offset:		resd	1
d__vicbase_frame_offset_unused:		resd	1
d__vicbase_frame_offset_next:		resd	1
ab__vicbase_registers:			resb	VIC6569_REGISTERS_SIZE
atvicline__vicbase_frame:		resb	((VIC6569_LINES_PER_FRAME + 2) * tvicline_size)
					endstruc



					struc	tvicdecode
					alignb	4
d__vicdecode_x_start:			resd	1
d__vicdecode_x_end:			resd	1
d__vicdecode_y_start:			resd	1
d__vicdecode_y_end:			resd	1
p__vicdecode_screen_start:		resd	1
p__vicdecode_screen:			resd	1
d__vicdecode_screen_line_length:	resd	1
p__vicdecode_lines:			resd	1
p__vicdecode_lines_list:		resd	1
p__vicdecode_function:			resd	1
d__vicdecode_frame_offset_last:		resd	1
d__vicdecode_frame_offset:		resd	1
d__vicdecode_state:			resd	1
ab__vicdecode_registers:		resb	VIC6569_REGISTERS_SIZE
ab__vicdecode_z_buffer:			resb	16
ab__vicdecode_color_index0:		resb	16
ab__vicdecode_color_index1:		resb	8
ab__vicdecode_color_index2:		resb	8
ab__vicdecode_color_index3:		resb	8
ab__vicdecode_lookup_table1:		resb	17
b__vicdecode_z_layer:			resb	1
b__vicdecode_sprite_z_layer:		resb	1
b__vicdecode_line_cycle:		resb	1
ab__vicdecode_lookup_table2:		resb	17
b__vicdecode_sprite_dma_mask_last:	resb	1
					resb	2
ab__vicdecode_lines_marked:		resd	VIC6569_LINES_PER_FRAME
					endstruc

%if b__vicdecode_sprite_dma_mask_last > 256
%error "b__tvicdecode_sprite_dma_mask_last is larger than 256 Bytes!"
%endif



					struc	tvic6569
					alignb	4
d__vic6569_modulid:			resd	1
d__vic6569_high_bits:			resd	1
tvicbase__vic6569_base:			resb	tvicbase_size
tvicdecode__vic6569_decode:		resb	tvicdecode_size
					endstruc



;****************************************************************************
;* assign's & defines's *****************************************************
;****************************************************************************
%define VICLINE_REGISTERS		ab__vicline_registers
%define VICLINE_CHANGE_LOG		ad__vicline_change_log
%define VICLINE_COLOR_RAM_CACHE		ab__vicline_color_ram_cache
%define VICLINE_VIDEO_CACHE		ab__vicline_video_cache
%define VICLINE_DATA_CACHE		ab__vicline_data_cache
%define VICLINE_SPRITE_DMA_MASK_LAST	b__vicline_sprite_dma_mask_last
%define VICLINE_STATE			d__vicline_state
%define VICLINE_LINE_COUNTER		d__vicline_line_counter
%define VICLINE_SPRITE_CACHE		ab__vicline_sprite_cache
%define VICLINE_SIZE			tvicline_size

%define VICBASE_STATE			d__vicbase_state
%define VICBASE_EXECUTE_CYCLE		p__vicbase_execute_cycle
%define VICBASE_EXECUTE_CYCLE_SWITCH	p__vicbase_execute_cycle_switch
%define VICBASE_CYCLE_COUNTER		d__vicbase_cycle_counter
%define VICBASE_ECM_ADDRESS_MASK	b__vicbase_ecm_address_mask
%define VICBASE_EXTRA_VIDEO_BYTE	b__vicbase_extra_video_byte
%define VICBASE_DMA_DELAY_COUNTER	b__vicbase_dma_delay_counter
%define VICBASE_SPRITE_DMA_MASK		b__vicbase_sprite_dma_mask
%define VICBASE_SPRITE_DMA_MASK_BASE	b__vicbase_sprite_dma_mask_base
%define VICBASE_SPRITE_DMA_MASK_LAST	b__vicbase_sprite_dma_mask_last
%define VICBASE_SPRITE_Y_EXPAND_MASK	b__vicbase_sprite_y_expand_mask
%define VICBASE_SPRITE_DMA_CYCLES	d__vicbase_sprite_dma_cycles
%define VICBASE_SPRITE_DMA_CYCLES_BASE	d__vicbase_sprite_dma_cycles_base
%define VICBASE_SPRITE_CACHE_OFFSET	d__vicbase_sprite_cache_offset
%define VICBASE_SPRITE_COUNTERS		ab__vicbase_sprite_counters
%define VICBASE_VIDEO_ADDRESS		d__vicbase_video_address
%define VICBASE_DATA_ADDRESS		d__vicbase_data_address
%define VICBASE_VIDEO_COUNTER		d__vicbase_video_counter
%define VICBASE_ROW_COUNTER		d__vicbase_row_counter
%define VICBASE_VIDEO_CACHE_OFFSET	d__vicbase_video_cache_offset
%define VICBASE_CHANGE_LOG_OFFSET	d__vicbase_change_log_offset
%define VICBASE_LINE_TIMESTAMP		q__vicbase_line_timestamp
%define VICBASE_LINE_COUNTER		d__vicbase_line_counter
%define VICBASE_LINE_LATCH		d__vicbase_line_latch
%define VICBASE_BORDER_LEFT		d__vicbase_border_left
%define VICBASE_BORDER_RIGHT		d__vicbase_border_right
%define VICBASE_BORDER_TOP		d__vicbase_border_top
%define VICBASE_BORDER_BUTTOM		d__vicbase_border_buttom
%define VICBASE_FRAME_OFFSET_LAST	d__vicbase_frame_offset_last
%define VICBASE_FRAME_OFFSET		d__vicbase_frame_offset
%define VICBASE_FRAME_OFFSET_UNUSED	d__vicbase_frame_offset_unused
%define VICBASE_FRAME_OFFSET_NEXT	d__vicbase_frame_offset_next
%define VICBASE_REGISTERS		ab__vicbase_registers
%define VICBASE_FRAME			atvicline__vicbase_frame
%define VICBASE_SIZE			tvicbase_size

%define VICDECODE_X_START		d__vicdecode_x_start
%define VICDECODE_X_END			d__vicdecode_x_end
%define VICDECODE_Y_START		d__vicdecode_y_start
%define VICDECODE_Y_END			d__vicdecode_y_end
%define VICDECODE_SCREEN_START		p__vicdecode_screen_start
%define VICDECODE_SCREEN		p__vicdecode_screen
%define VICDECODE_SCREEN_LINE_LENGTH	d__vicdecode_screen_line_length
%define VICDECODE_LINES			p__vicdecode_lines
%define VICDECODE_LINES_LIST		p__vicdecode_lines_list
%define VICDECODE_FUNCTION		p__vicdecode_function
%define VICDECODE_FRAME_OFFSET_LAST	d__vicdecode_frame_offset_last
%define VICDECODE_FRAME_OFFSET		d__vicdecode_frame_offset
%define VICDECODE_STATE			d__vicdecode_state
%define VICDECODE_REGISTERS		ab__vicdecode_registers
%define VICDECODE_Z_BUFFER		ab__vicdecode_z_buffer
%define VICDECODE_COLOR_INDEX0		ab__vicdecode_color_index0
%define VICDECODE_COLOR_INDEX1		ab__vicdecode_color_index1
%define VICDECODE_COLOR_INDEX2		ab__vicdecode_color_index2
%define VICDECODE_COLOR_INDEX3		ab__vicdecode_color_index3
%define VICDECODE_LOOKUP_TABLE1		ab__vicdecode_lookup_table1
%define VICDECODE_Z_LAYER		b__vicdecode_z_layer
%define VICDECODE_SPRITE_Z_LAYER	b__vicdecode_sprite_z_layer
%define VICDECODE_LINE_CYCLE		b__vicdecode_line_cycle
%define VICDECODE_LOOKUP_TABLE2		ab__vicdecode_lookup_table2
%define VICDECODE_SPRITE_DMA_MASK_LAST	b__vicdecode_sprite_dma_mask_last
%define VICDECODE_LINES_MARKED		ab__vicdecode_lines_marked
%define VICDECODE_SIZE			tvicdecode_size

%define	VIC6569_MODULID			esi + tvic6569__c64 + d__vic6569_modulid
%define VIC6569_HIGH_BITS		esi + tvic6569__c64 + d__vic6569_high_bits
%define VIC6569_BASE			esi + tvic6569__c64 + tvicbase__vic6569_base
%define VIC6569_DECODE			esi + tvic6569__c64 + tvicdecode__vic6569_decode



%define VIC6569_BASE_STATE			VIC6569_BASE + VICBASE_STATE
%define VIC6569_BASE_EXECUTE_CYCLE		VIC6569_BASE + VICBASE_EXECUTE_CYCLE
%define VIC6569_BASE_EXECUTE_CYCLE_SWITCH	VIC6569_BASE + VICBASE_EXECUTE_CYCLE_SWITCH
%define VIC6569_BASE_CYCLE_COUNTER		VIC6569_BASE + VICBASE_CYCLE_COUNTER
%define VIC6569_BASE_ECM_ADDRESS_MASK		VIC6569_BASE + VICBASE_ECM_ADDRESS_MASK
%define VIC6569_BASE_EXTRA_VIDEO_BYTE		VIC6569_BASE + VICBASE_EXTRA_VIDEO_BYTE
%define VIC6569_BASE_DMA_DELAY_COUNTER		VIC6569_BASE + VICBASE_DMA_DELAY_COUNTER
%define VIC6569_BASE_SPRITE_DMA_MASK		VIC6569_BASE + VICBASE_SPRITE_DMA_MASK
%define VIC6569_BASE_SPRITE_DMA_MASK_BASE	VIC6569_BASE + VICBASE_SPRITE_DMA_MASK_BASE
%define VIC6569_BASE_SPRITE_DMA_MASK_LAST	VIC6569_BASE + VICBASE_SPRITE_DMA_MASK_LAST
%define VIC6569_BASE_SPRITE_Y_EXPAND_MASK	VIC6569_BASE + VICBASE_SPRITE_Y_EXPAND_MASK
%define VIC6569_BASE_SPRITE_DMA_CYCLES		VIC6569_BASE + VICBASE_SPRITE_DMA_CYCLES
%define VIC6569_BASE_SPRITE_DMA_CYCLES_BASE	VIC6569_BASE + VICBASE_SPRITE_DMA_CYCLES_BASE
%define VIC6569_BASE_SPRITE_CACHE_OFFSET	VIC6569_BASE + VICBASE_SPRITE_CACHE_OFFSET
%define VIC6569_BASE_SPRITE_COUNTERS		VIC6569_BASE + VICBASE_SPRITE_COUNTERS
%define VIC6569_BASE_VIDEO_ADDRESS		VIC6569_BASE + VICBASE_VIDEO_ADDRESS
%define VIC6569_BASE_DATA_ADDRESS		VIC6569_BASE + VICBASE_DATA_ADDRESS
%define VIC6569_BASE_VIDEO_COUNTER		VIC6569_BASE + VICBASE_VIDEO_COUNTER
%define VIC6569_BASE_ROW_COUNTER		VIC6569_BASE + VICBASE_ROW_COUNTER
%define VIC6569_BASE_VIDEO_CACHE_OFFSET		VIC6569_BASE + VICBASE_VIDEO_CACHE_OFFSET
%define VIC6569_BASE_CHANGE_LOG_OFFSET		VIC6569_BASE + VICBASE_CHANGE_LOG_OFFSET
%define VIC6569_BASE_LINE_TIMESTAMP		VIC6569_BASE + VICBASE_LINE_TIMESTAMP
%define VIC6569_BASE_LINE_COUNTER		VIC6569_BASE + VICBASE_LINE_COUNTER
%define VIC6569_BASE_LINE_LATCH			VIC6569_BASE + VICBASE_LINE_LATCH
%define VIC6569_BASE_BORDER_LEFT		VIC6569_BASE + VICBASE_BORDER_LEFT
%define VIC6569_BASE_BORDER_RIGHT		VIC6569_BASE + VICBASE_BORDER_RIGHT
%define VIC6569_BASE_BORDER_TOP			VIC6569_BASE + VICBASE_BORDER_TOP
%define VIC6569_BASE_BORDER_BUTTOM		VIC6569_BASE + VICBASE_BORDER_BUTTOM
%define VIC6569_BASE_FRAME_OFFSET_LAST		VIC6569_BASE + VICBASE_FRAME_OFFSET_LAST
%define VIC6569_BASE_FRAME_OFFSET		VIC6569_BASE + VICBASE_FRAME_OFFSET
%define VIC6569_BASE_FRAME_OFFSET_UNUSED	VIC6569_BASE + VICBASE_FRAME_OFFSET_UNUSED
%define VIC6569_BASE_FRAME_OFFSET_NEXT		VIC6569_BASE + VICBASE_FRAME_OFFSET_NEXT
%define VIC6569_BASE_REGISTERS			VIC6569_BASE + VICBASE_REGISTERS
%define VIC6569_BASE_FRAME			VIC6569_BASE + VICBASE_FRAME

%define VIC6569_DECODE_X_START			VIC6569_DECODE + VICDECODE_X_START
%define VIC6569_DECODE_X_END			VIC6569_DECODE + VICDECODE_X_END
%define VIC6569_DECODE_Y_START			VIC6569_DECODE + VICDECODE_Y_START
%define VIC6569_DECODE_Y_END			VIC6569_DECODE + VICDECODE_Y_END
%define VIC6569_DECODE_SCREEN_START		VIC6569_DECODE + VICDECODE_SCREEN_START
%define VIC6569_DECODE_SCREEN			VIC6569_DECODE + VICDECODE_SCREEN
%define VIC6569_DECODE_SCREEN_LINE_LENGTH	VIC6569_DECODE + VICDECODE_SCREEN_LINE_LENGTH
%define VIC6569_DECODE_LINES			VIC6569_DECODE + VICDECODE_LINES
%define VIC6569_DECODE_LINES_LIST		VIC6569_DECODE + VICDECODE_LINES_LIST
%define VIC6569_DECODE_FUNCTION			VIC6569_DECODE + VICDECODE_FUNCTION
%define VIC6569_DECODE_FRAME_OFFSET_LAST	VIC6569_DECODE + VICDECODE_FRAME_OFFSET_LAST
%define VIC6569_DECODE_FRAME_OFFSET		VIC6569_DECODE + VICDECODE_FRAME_OFFSET
%define VIC6569_DECODE_STATE			VIC6569_DECODE + VICDECODE_STATE
%define VIC6569_DECODE_REGISTERS		VIC6569_DECODE + VICDECODE_REGISTERS
%define VIC6569_DECODE_Z_BUFFER			VIC6569_DECODE + VICDECODE_Z_BUFFER
%define VIC6569_DECODE_COLOR_INDEX0		VIC6569_DECODE + VICDECODE_COLOR_INDEX0
%define VIC6569_DECODE_COLOR_INDEX1		VIC6569_DECODE + VICDECODE_COLOR_INDEX1
%define VIC6569_DECODE_COLOR_INDEX2		VIC6569_DECODE + VICDECODE_COLOR_INDEX2
%define VIC6569_DECODE_COLOR_INDEX3		VIC6569_DECODE + VICDECODE_COLOR_INDEX3
%define VIC6569_DECODE_LOOKUP_TABLE1		VIC6569_DECODE + VICDECODE_LOOKUP_TABLE1
%define VIC6569_DECODE_Z_LAYER			VIC6569_DECODE + VICDECODE_Z_LAYER
%define VIC6569_DECODE_SPRITE_Z_LAYER		VIC6569_DECODE + VICDECODE_SPRITE_Z_LAYER
%define VIC6569_DECODE_LINE_CYCLE		VIC6569_DECODE + VICDECODE_LINE_CYCLE
%define VIC6569_DECODE_LOOKUP_TABLE2		VIC6569_DECODE + VICDECODE_LOOKUP_TABLE2
%define VIC6569_DECODE_SPRITE_DMA_MASK_LAST	VIC6569_DECODE + VICDECODE_SPRITE_DMA_MASK_LAST
%define VIC6569_DECODE_LINES_MARKED		VIC6569_DECODE + VICDECODE_LINES_MARKED



%assign VIC6569_STATE_DISPLAY_DISABLE			000000001h
%assign VIC6569_STATE_DISPLAY_MODE			000000002h
%assign VIC6569_STATE_BORDER_MAIN			000000004h
%assign VIC6569_STATE_BORDER_VERTICAL			000000008h
%assign VIC6569_STATE_FORCE_DECODING			000000010h
%assign VIC6569_STATE_BAD_LINE				000000100h
%assign VIC6569_STATE_BAD_LINE_EXPECTED			000000200h
%assign VIC6569_STATE_ACCESS_GRANTED			000000400h
%assign VIC6569_STATE_VIDEO_ADDRESS_IN_RAM		000000800h
%assign VIC6569_STATE_RESET_IN_PROGRESS			000001000h





;****************************************************************************
;* Macro's ******************************************************************
;****************************************************************************
%macro VIC6569_CALL_INITIALIZE 0
			call	vic6569_initialize
%endmacro



%macro VIC6569_CALL_INSTANCE_INITIALIZE 1
			call	vic6569_instance_initialize
			mov	dword eax, %1
			mov	dword [VIC6569_MODULID], eax
%endmacro



%macro VIC6569_CALL_RESET_HARD 0
			call	vic6569_reset_hard
%endmacro



%macro VIC6569_CALL_RESET_SOFT 0
			call	vic6569_reset_soft
%endmacro



%macro VIC6569_CALL_READ 0
			call	vic6569_read
%endmacro



%macro VIC6569_CALL_WRITE 0
			call	vic6569_write
%endmacro



%macro VIC6569_CALL_CYCLE 0
%ifdef VIC6569_LOG_HACK
			test	dword [VIC6569_BASE_STATE], 010000000h
			jz	%%skip
			call	vic6569_log
%%skip:
%endif ;VIC6569_LOG_HACK
			call	dword [VIC6569_BASE_EXECUTE_CYCLE]
%endmacro



%endif
;******************************************************** ec64@unusedino.de *

