/****************************************************************************
 ****************************************************************************
 *
 * core.h
 *
 ****************************************************************************
 ****************************************************************************/





#ifndef EC64CORE_CORE_H
#define EC64CORE_CORE_H

#define CORE_ERROR_EXCEPTION		1
#define CORE_ERROR_ASSERTION		2
#define CORE_ERROR_TRAP			3
#define CORE_ERROR_BPLOG_FULL		4
#define CORE_ERROR_NOT_IMPLEMENTED	5
#define CORE_ERROR_BAD_VALUE		6
#define CORE_ERROR_BAD_BPTYPE		7
#define CORE_ERROR_BPTABLE_FULL		8
#define CORE_ERROR_BAD_MODULID		9

#define CORE_MODULID_CORE		1
#define CORE_MODULID_LINK		2
#define CORE_MODULID_C64LINK		3
#define CORE_MODULID_C64MEMORY		4
#define CORE_MODULID_C64CPU		5
#define CORE_MODULID_C64VIC		6
#define CORE_MODULID_C64SID		7
#define CORE_MODULID_C64CIA1		8
#define CORE_MODULID_C64CIA2		9
#define CORE_MODULID_C1541LINK		10
#define CORE_MODULID_C1541MEMORY	11
#define CORE_MODULID_C1541CPU		12
#define CORE_MODULID_C1541VIA1		13
#define CORE_MODULID_C1541VIA2		14
#define CORE_MODULID_C1541DISC		15

#define CORE_BPFLAG_TRAP		1
#define CORE_BPFLAG_LOG			2

#define CORE_BPTYPE_CPU_READ_OPCODE	1
#define CORE_BPTYPE_CPU_READ_STACK	2
#define CORE_BPTYPE_CPU_READ_DATA	3
#define CORE_BPTYPE_CPU_WRITE_STACK	4
#define CORE_BPTYPE_CPU_WRITE_DATA	5
#define CORE_BPTYPE_VIC_IRQ		6
#define CORE_BPTYPE_CIA_IRQ		7
#define CORE_BPTYPE_VIA_IRQ		8

typedef struct
	{
	d				modulid;
	d				type;
	d				number;
	}
tcoreinfo;


#endif
/******************************************************** ec64@unusedino.de */

