/****************************************************************************
 ****************************************************************************
 *
 * ec64core.h
 *
 ****************************************************************************
 ****************************************************************************/





#ifndef EC64CORE_H
#define EC64CORE_H

#include "ec64types.h"
#include "io/audio.h"
#include "io/status.h"
#include "io/video.h"
#include "core/core.h"
#include "core/cpu65xx.h"
#include "core/disc.h"

extern const b				*ec64core_get_version(void);
extern void				ec64core_initialize(void);
extern void				ec64core_reset_hard(void);
extern void				ec64core_reset_soft(void);
extern sd				ec64core_emulate_pal_frame(void);
extern void				ec64core_c64_set_video_options(const tvideo *);
extern void				ec64core_c64_set_audio_options(const taudio *);
extern void				ec64core_c64_set_keyboard(const b *);
extern void				ec64core_c64_set_joystick1(const d);
extern void				ec64core_c64_set_joystick2(const d);
extern void				ec64core_c64_set_basic_rom(const b *);
extern void				ec64core_c64_set_character_rom(const b *);
extern void				ec64core_c64_set_kernel_rom(const b *);
extern const tc64stat			*ec64core_c64_get_status(void);
extern const b				*ec64core_c1541_get_disc_image(void);
extern void				ec64core_c1541_set_disc_image(const b *);
extern void				ec64core_c1541_set_kernel_rom(const b *);
extern const tc1541stat			*ec64core_c1541_get_status(void);

extern sd				ec64core_bp_entries(const d, const d, d *);
extern sd				ec64core_bp_get(const d, const d, void *);
extern sd				ec64core_bp_add(const d, const d, void *);
extern sd				ec64core_bp_delete(const d, const d, const d);

extern sd				ec64core_get_information(tcoreinfo *);
extern sd				ec64core_set_log_options(b *, d *, const d);



#endif
/******************************************************** ec64@unusedino.de */

