;****************************************************************************
;****************************************************************************
;*
;* ec64core.i
;*
;****************************************************************************
;****************************************************************************





%ifndef EC64CORE_I
%define EC64CORE_I

%include "ec64types.i"
%include "io/audio.i"
%include "io/status.i"
%include "io/video.i"
%include "core/core.i"
%include "core/cpu65xx.i"
%include "core/disc.i"

;****************************************************************************
;* Exported Symbols *********************************************************
;****************************************************************************
%ifdef EC64CORE_N
global ec64core_get_version
global ec64core_initialize
global ec64core_reset_hard
global ec64core_reset_soft
global ec64core_emulate_pal_frame
global ec64core_c64_set_video_options
global ec64core_c64_set_audio_options
global ec64core_c64_set_keyboard
global ec64core_c64_set_joystick1
global ec64core_c64_set_joystick2
global ec64core_c64_set_basic_rom
global ec64core_c64_set_character_rom
global ec64core_c64_set_kernel_rom
global ec64core_c64_get_status
global ec64core_c1541_get_disc_image
global ec64core_c1541_set_disc_image
global ec64core_c1541_set_kernel_rom
global ec64core_c1541_get_status
global ec64core_bp_entries
global ec64core_bp_get
global ec64core_bp_add
global ec64core_bp_delete
global ec64core_get_information
global ec64core_set_log_options
%else
extern ec64core_get_version
extern ec64core_initialize
extern ec64core_reset_hard
extern ec64core_reset_soft
extern ec64core_emulate_pal_frame
extern ec64core_c64_set_video_options
extern ec64core_c64_set_audio_options
extern ec64core_c64_set_keyboard
extern ec64core_c64_set_joystick1
extern ec64core_c64_set_joystick2
extern ec64core_c64_set_basic_rom
extern ec64core_c64_set_character_rom
extern ec64core_c64_set_kernel_rom
extern ec64core_c64_get_status
extern ec64core_c1541_get_disc_image
extern ec64core_c1541_set_disc_image
extern ec64core_c1541_set_kernel_rom
extern ec64core_c1541_get_status
extern ec64core_bp_entries
extern ec64core_bp_get
extern ec64core_bp_add
extern ec64core_bp_delete
extern ec64core_get_information
extern ec64core_set_log_options
%endif



%endif
;******************************************************** ec64@unusedino.de *

