/****************************************************************************
 ****************************************************************************
 *
 * ec64io.h
 *
 ****************************************************************************
 ****************************************************************************/





#ifndef EC64IO_H
#define EC64IO_H

#include "ec64types.h"
#include "io/string.h"
#include "io/audio.h"
#include "io/video.h"
#include "io/status.h"

extern const b				*ec64io_get_version(void);
extern void				ec64io_start(d, b *[]);
extern void				ec64io_initialize(void);
extern void				ec64io_restore(void);
extern void				ec64io_end(void);
extern void				ec64io_exit(const d);
extern void				ec64io_error(const b *);
extern void				ec64io_dump(const void *, const d);
extern const b				*ec64io_get_error_message(void);

extern d				ec64io_get_status(void);
extern void				ec64io_set_status(const d);

extern d				ec64io_string_print(b *, const d, const b *, ...);
extern d				ec64io_string_length(const b *);
extern sd				ec64io_string_compare(const b *, const b *);

extern void				ec64io_memory_fill(void *, const d, const b);
extern void				ec64io_memory_copy(void *, const void *, const d);

extern const tvideo			*ec64io_c64_get_video_options(void);
extern void				ec64io_c64_draw_screen(void);
extern const taudio			*ec64io_c64_get_audio_options(void);
extern void				ec64io_c64_play_samples(void);
extern const b				*ec64io_c64_get_keyboard(void);
extern d				ec64io_c64_get_joystick1(void);
extern d				ec64io_c64_get_joystick2(void);
extern void				ec64io_c64_draw_status(const tc64stat *);
extern void				ec64io_c1541_draw_status(const tc1541stat *);

extern const b				*ec64io_cmdline_d64_path(void);
extern const b				*ec64io_cmdline_script_path(void);
extern sd				ec64io_file_load(const b *, b *, const d);
extern sd				ec64io_file_save(const b *, const b *, const d);

extern void				ec64io_tty_print_text(const b *);
extern void				ec64io_tty_print_error(const b *);

extern void				ec64io_sync_sleep(void);

extern b				ec64io_monitor_get_character(void);
extern void				ec64io_monitor_print_text(const b *);
extern void				ec64io_monitor_print_notice(const b *);
extern void				ec64io_monitor_print_error(const b *);
extern void				ec64io_monitor_new_line(void);
extern void				ec64io_monitor_delete_character(void);

extern void				ec64io_log_path(const b *);
extern sd				ec64io_log_write(const b *, const d);



#endif
/******************************************************** ec64@unusedino.de */

