/****************************************************************************
 ****************************************************************************
 *
 * ec64sys.h
 *
 ****************************************************************************
 ****************************************************************************/





#ifndef EC64SYS_H
#define EC64SYS_H

#include "ec64types.h"
#include "sys/audio.h"
#include "sys/fb.h"
#include "sys/fcntl.h"
#include "sys/mmap.h"
#include "sys/signal.h"
#include "sys/socket.h"
#include "sys/stat.h"
#include "sys/time.h"
#include "sys/tty.h"

#define EC64SYS_OS_UNKNOWN		-1
#define EC64SYS_OS_LINUX		0
#define EC64SYS_OS_FREEBSD		1

extern const b				*ec64sys_get_version(void);

extern const sd				ec64sys_error_number;
extern const sd				ec64sys_os_type;

extern sd				ec64sys_exit(const d);
extern sd				ec64sys_open(const b *, const d, ...);
extern sd				ec64sys_close(const d);
extern sd				ec64sys_getuid(void);
extern sd				ec64sys_getgid(void);
extern sd				ec64sys_signal(const d, const tsighandler);
extern sd				ec64sys_read(const d, void *, const d);
extern sd				ec64sys_write(const d, const void *, const d);
extern sd				ec64sys_ioctl(const d, const d, ...);
extern sd				ec64sys_fcntl(const d, const d, ...);
extern void				*ec64sys_mmap(const tmmap *);
extern sd				ec64sys_munmap(void *, const d);
extern sd				ec64sys_ioperm(const d, const d, const d);
extern sd				ec64sys_socketcall(const d, const void *);
extern sd				ec64sys_setfsuid(const d);
extern sd				ec64sys_setfsgid(const d);
extern sd				ec64sys_select(const d, void *, void *, void *, ttimeval *);

extern d				ec64sys_time(void);
extern void				ec64sys_sleep(const d);

extern b				ec64sys_inb(const d);
extern w				ec64sys_inw(const d);
extern d				ec64sys_ind(const d);
extern void				ec64sys_outb(const d, const b);
extern void				ec64sys_outw(const d, const w);
extern void				ec64sys_outd(const d, const d);



#endif
/******************************************************** ec64@unusedino.de */

