;****************************************************************************
;****************************************************************************
;*
;* ec64sys.i
;*
;****************************************************************************
;****************************************************************************





%ifndef EC64SYS_I
%define EC64SYS_I

%include "ec64types.i"
%include "sys/audio.i"
%include "sys/fb.i"
%include "sys/fcntl.i"
%include "sys/mmap.i"
%include "sys/signal.i"
%include "sys/socket.i"
%include "sys/stat.i"
%include "sys/time.i"
%include "sys/tty.i"

;****************************************************************************
;* Exported Symbols *********************************************************
;****************************************************************************
%ifdef EC64SYS_N
global ec64sys_get_version
global ec64sys_error_number
global ec64sys_os_type
global ec64sys_start
global ec64sys_exit
global ec64sys_open
global ec64sys_close
global ec64sys_getuid
global ec64sys_getgid
global ec64sys_signal
global ec64sys_read
global ec64sys_write
global ec64sys_ioctl
global ec64sys_fcntl
global ec64sys_mmap
global ec64sys_munmap
global ec64sys_ioperm
global ec64sys_socketcall
global ec64sys_setfsuid
global ec64sys_setfsgid
global ec64sys_select
global ec64sys_time
global ec64sys_sleep
global ec64sys_inb
global ec64sys_inw
global ec64sys_ind
global ec64sys_outb
global ec64sys_outw
global ec64sys_outd
%else
extern ec64sys_get_version
extern ec64sys_error_number
extern ec64sys_os_type
extern ec64sys_start
extern ec64sys_exit
extern ec64sys_open
extern ec64sys_close
extern ec64sys_signal
extern ec64sys_read
extern ec64sys_write
extern ec64sys_ioctl
extern ec64sys_fcntl
extern ec64sys_mmap
extern ec64sys_munmap
extern ec64sys_ioperm
extern ec64sys_socketcall
extern ec64sys_setfsuid
extern ec64sys_setfsgid
extern ec64sys_select
extern ec64sys_time
extern ec64sys_sleep
extern ec64sys_inb
extern ec64sys_inw
extern ec64sys_ind
extern ec64sys_outb
extern ec64sys_outw
extern ec64sys_outd
%endif



;****************************************************************************
;* assign's & define's ******************************************************
;****************************************************************************
%assign EC64SYS_OS_UNKNOWN		-1
%assign EC64SYS_OS_LINUX		0
%assign EC64SYS_OS_FREEBSD		1



%endif
;******************************************************** ec64@unusedino.de *

