/****************************************************************************
 ****************************************************************************
 *
 * audio.h
 *
 ****************************************************************************
 ****************************************************************************/





#ifndef EC64SYS_AUDIO_H
#define EC64SYS_AUDIO_H

#define SNDCTL_DSP_RESET		0x00005000
#define SNDCTL_DSP_NONBLOCK		0x0000500e
#define SNDCTL_DSP_GETODELAY		0x80045017
#define SNDCTL_DSP_SPEED		0xc0045002
#define SNDCTL_DSP_GETBLKSIZE		0xc0045004
#define SNDCTL_DSP_SETFMT		0xc0045005
#define SNDCTL_DSP_CHANNELS		0xc0045006

#define SOUND_PCM_RESET			SNDCTL_DSP_RESET
#define SOUND_PCM_NONBLOCK		SNDCTL_DSP_NONBLOCK
#define SOUND_PCM_WRITE_RATE		SNDCTL_DSP_SPEED
#define SOUND_PCM_SETFMT		SNDCTL_DSP_SETFMT
#define SOUND_PCM_WRITE_BITS		SNDCTL_DSP_SETFMT
#define 	AFMT_QUERY		0x00000000
#define		AFMT_MU_LAW		0x00000001
#define 	AFMT_A_LAW		0x00000002
#define 	AFMT_IMA_ADPCM		0x00000004
#define 	AFMT_U8			0x00000008
#define 	AFMT_S16_LE		0x00000010	/* little endian */
#define 	AFMT_S16_BE		0x00000020	/* big endian */
#define 	AFMT_S8			0x00000040
#define 	AFMT_U16_LE		0x00000080	/* little endian */
#define 	AFMT_U16_BE		0x00000100	/* big endian */
#define 	AFMT_MPEG		0x00000200	/* MPEG 2 audio */
#define SOUND_PCM_WRITE_CHANNELS	SNDCTL_DSP_CHANNELS
#define SOUND_MIXER_WRITE_VOLUME	0xc0044d00
#define SOUND_MIXER_WRITE_PCM		0xc0044d04
#define 	SOUND_MIXER_VOLUME	0
#define 	SOUND_MIXER_BASS	1
#define 	SOUND_MIXER_TREBLE	2
#define 	SOUND_MIXER_SYNTH	3
#define 	SOUND_MIXER_PCM		4
#define 	SOUND_MIXER_SPEAKER	5
#define 	SOUND_MIXER_LINE	6
#define 	SOUND_MIXER_MIC		7
#define 	SOUND_MIXER_CD		8
#define 	SOUND_MIXER_IMIX	9	/* Recording monitor */
#define 	SOUND_MIXER_ALTPCM	10
#define 	SOUND_MIXER_RECLEV	11	/* Recording level */
#define 	SOUND_MIXER_IGAIN	12	/* Input gain */
#define 	SOUND_MIXER_OGAIN	13	/* Output gain */
#define 	SOUND_MIXER_LINE1	14	/* Input source 1  (aux1) */
#define 	SOUND_MIXER_LINE2	15	/* Input source 2  (aux2) */
#define 	SOUND_MIXER_LINE3	16	/* Input source 3  (line) */
#define 	SOUND_MIXER_DIGITAL1	17	/* Digital (input) 1 */
#define 	SOUND_MIXER_DIGITAL2	18	/* Digital (input) 2 */
#define 	SOUND_MIXER_DIGITAL3	19	/* Digital (input) 3 */
#define 	SOUND_MIXER_PHONEIN	20	/* Phone input */
#define 	SOUND_MIXER_PHONEOUT	21	/* Phone output */
#define 	SOUND_MIXER_VIDEO	22	/* Video/TV (audio) in */
#define 	SOUND_MIXER_RADIO	23	/* Radio in */
#define 	SOUND_MIXER_MONITOR	24	/* Monitor (usually mic) volume */
#define 	SOUND_MASK_VOLUME	(1 << SOUND_MIXER_VOLUME)
#define 	SOUND_MASK_BASS		(1 << SOUND_MIXER_BASS)
#define 	SOUND_MASK_TREBLE	(1 << SOUND_MIXER_TREBLE)
#define 	SOUND_MASK_SYNTH	(1 << SOUND_MIXER_SYNTH)
#define 	SOUND_MASK_PCM		(1 << SOUND_MIXER_PCM)
#define 	SOUND_MASK_SPEAKER	(1 << SOUND_MIXER_SPEAKER)
#define 	SOUND_MASK_LINE		(1 << SOUND_MIXER_LINE)
#define 	SOUND_MASK_MIC		(1 << SOUND_MIXER_MIC)
#define 	SOUND_MASK_CD		(1 << SOUND_MIXER_CD)
#define 	SOUND_MASK_IMIX		(1 << SOUND_MIXER_IMIX)
#define 	SOUND_MASK_ALTPCM	(1 << SOUND_MIXER_ALTPCM)
#define 	SOUND_MASK_RECLEV	(1 << SOUND_MIXER_RECLEV)
#define 	SOUND_MASK_IGAIN	(1 << SOUND_MIXER_IGAIN)
#define 	SOUND_MASK_OGAIN	(1 << SOUND_MIXER_OGAIN)
#define 	SOUND_MASK_LINE1	(1 << SOUND_MIXER_LINE1)
#define 	SOUND_MASK_LINE2	(1 << SOUND_MIXER_LINE2)
#define 	SOUND_MASK_LINE3	(1 << SOUND_MIXER_LINE3)
#define 	SOUND_MASK_DIGITAL1	(1 << SOUND_MIXER_DIGITAL1)
#define 	SOUND_MASK_DIGITAL2	(1 << SOUND_MIXER_DIGITAL2)
#define 	SOUND_MASK_DIGITAL3	(1 << SOUND_MIXER_DIGITAL3)
#define 	SOUND_MASK_PHONEIN	(1 << SOUND_MIXER_PHONEIN)
#define 	SOUND_MASK_PHONEOUT	(1 << SOUND_MIXER_PHONEOUT)
#define 	SOUND_MASK_RADIO	(1 << SOUND_MIXER_RADIO)
#define 	SOUND_MASK_VIDEO	(1 << SOUND_MIXER_VIDEO)
#define 	SOUND_MASK_MONITOR	(1 << SOUND_MIXER_MONITOR)



#endif
/******************************************************** ec64@unusedino.de */

