/****************************************************************************
 ****************************************************************************
 *
 * fb.h
 *
 ****************************************************************************
 ****************************************************************************/





#ifndef EC64SYS_FB_H
#define EC64SYS_FB_H

#define FBIOGET_VSCREENINFO	0x4600
#define FBIOPUT_VSCREENINFO	0x4601
#define FBIOGETCMAP		0x4604
#define FBIOPUTCMAP		0x4605

#define FB_ACTIVATE_NOW		0	/* set values immediately (or vbl) */
#define FB_ACTIVATE_NXTOPEN	1	/* activate on next open */
#define FB_ACTIVATE_TEST	2	/* don't set, round up impossible */
#define FB_ACTIVATE_MASK	15	/* values */
#define FB_ACTIVATE_VBL		16	/* activate values on next vbl */
#define FB_CHANGE_CMAP_VBL	32	/* change colormap on vbl */
#define FB_ACTIVATE_ALL		64	/* change all VCs on this fb */

#define FB_ACCELF_TEXT		1	/* text mode acceleration */

#define FB_SYNC_HOR_HIGH_ACT	1	/* horizontal sync high active */
#define FB_SYNC_VERT_HIGH_ACT	2	/* vertical sync high active */
#define FB_SYNC_EXT		4	/* external sync */
#define FB_SYNC_COMP_HIGH_ACT	8	/* composite sync high active */
#define FB_SYNC_BROADCAST	16	/* broadcast video timings */
					/* vtotal = 144d/288n/576i => PAL */
					/* vtotal = 121d/242n/484i => NTSC */
#define FB_SYNC_ON_GREEN	32	/* sync on green */

#define FB_VMODE_NONINTERLACED  0	/* non interlaced */
#define FB_VMODE_INTERLACED	1	/* interlaced */
#define FB_VMODE_DOUBLE		2	/* double scan */
#define FB_VMODE_MASK		255

#define FB_VMODE_YWRAP		256	/* ywrap instead of panning */
#define FB_VMODE_SMOOTH_XPAN	512	/* smooth xpan possible (kernel internally used) */
#define FB_VMODE_CONUPDATE	512	/* don't update x/yoffset */



typedef struct
	{
	d		offset;
	d		length;
	w		*red;
	w		*green;
	w		*blue;
	w		*transparent;
	}
tcmap;



typedef struct
	{
	d		x_resolution;
	d		y_resolution;
	d		virtual_x_resolution;
	d		virtual_y_resolution;
	d		x_offset;
	d		y_offset;
	d		bits_per_pixel;
	d		grayscale;
	d		red_offset;
	d		red_length;
	d		red_msb_right;
	d		green_offset;
	d		green_length;
	d		green_msb_right;
	d 		blue_offset;
	d		blue_length;
	d		blue_msb_right;
	d		transparent_offset;
	d		transparent_length;
	d		transparent_msb_right;
	d		non_standard_format;
	d		activate;
	d		height;
	d		width;
	d		acceleration_flags;
	d		pixel_clock;
	d		left_margin;
	d		right_margin;
	d		upper_margin;
	d		lower_margin;
	d		hsync_length;
	d		vsync_length;
	d		sync;
	d		vmode;
	d		reserved[6];
	}
tscreen;



#endif
/******************************************************** ec64@unusedino.de */

