/****************************************************************************
 ****************************************************************************
 *
 * tty.h
 *
 ****************************************************************************
 ****************************************************************************/





#ifndef EC64SYS_TTY_H
#define EC64SYS_TTY_H

#define TCGETS			0x5401
#define TCSETS			0x5402
#define TCSETSW			0x5403
#define TIOCLINUX		0x541c

#define VT_OPENQRY		0x5600
#define VT_GETMODE		0x5601
#define VT_SETMODE		0x5602
#define 	VT_AUTO		0
#define 	VT_PROCESS	1
#define 	VT_ACKACQ	2
#define VT_GETSTATE		0x5603
#define VT_SENDSIG 		0x5604
#define VT_RELDISP		0x5605
#define VT_ACTIVATE		0x5606
#define VT_WAITACTIVE		0x5607
#define VT_DISALLOCATE		0x5608
#define VT_RESIZE		0x5609
#define VT_RESIZEX		0x560a
#define VT_LOCKSWITCH		0x560b
#define VT_UNLOCKSWITCH		0x560c

#define KDGETLED		0x4b31
#define KDSETLED		0x4b32
#define KDSETMODE		0x4b3a
#define KDGETMODE		0x4b3b
#define KDGKBMODE		0x4b44
#define KDSKBMODE		0x4b45
#define KDGKBENT		0x4b46

#define KD_TEXT			0
#define KD_GRAPHICS		1

#define K_RAW			0x00
#define K_XLATE			0x01
#define K_MEDIUMRAW		0x02

#define NR_KEYS			128

#define KG_SHIFT		0
#define KG_ALTGR		1
#define KG_CTRL			2
#define KG_ALT			3
#define KG_SHIFTL		4
#define KG_SHIFTR		5
#define KG_CTRLL		6
#define KG_CTRLR		7
#define KG_CAPSSHIFT		8

/* input flags */
#define ISTRIP			000040
#define INLCR			000100
#define IGNCR			000200
#define ICRNL			000400
#define IXON			002000
#define IXOFF			010000

/* local flags */
#define ISIG			1
#define ICANON			2
#define ECHO			8

/* control characters */
#define VINTR			0
#define VQUIT			1
#define VERASE			2
#define VKILL			3
#define VEOF			4
#define VTIME			5
#define VMIN			6
#define VSWTC			7
#define VSTART			8
#define VSTOP			9
#define VSUSP			10
#define VEOL			11
#define VREPRINT		12
#define VDISCARD		13
#define VWERASE			14
#define VLNEXT			15
#define VEOL2			16

typedef struct
	{
	d		input_flags;
	d		output_flags;
	d		control_flags;
	d		local_flags;
	d		line_discipline;
	b		control_characters[64];
	}
ttermios;

typedef struct
	{
	b		mode;
	b		waitv;
	b		relsig;
	b		acqsig;
	b		fwsig;
	}
tvtmode;

typedef struct
	{
	b		table;
	b		index;
	w		value;
	}
tkbentry;



#endif
/******************************************************** ec64@unusedino.de */

