/****************************************************************************
 ****************************************************************************
 *
 * gpm.c
 *
 ****************************************************************************
 ****************************************************************************/





#include "gpm.h"
#include "ec64sys.h"
#include "error.h"
#include "memory.h"



#ifndef EC64_ENABLE_KDSETMODE
static d		gpm_state = 0;
static d		gpm_handle;
static b		gpm_path[] = "/dev/gpmctl";

#define GPM_INITIALIZED		0x01
#define GPM_OPEN		0x02



/****************************************************************************
 * gpm_initialize ***********************************************************
 ****************************************************************************/
void	gpm_initialize(
	void)

	{
	d				socket[3] =
					{
					AF_UNIX,
					SOCK_STREAM,
					0
					};
	tsockaddrun			socket_unix;
	d				connect[3] =
					{
					0,
					0,
					sizeof(tsockaddrun)
					};
    

	if (gpm_state & GPM_INITIALIZED)
		error_text_exit(STRING_TYPE "!INTERNAL FAILURE! gpm.c: already initialized");
	gpm_state |= GPM_INITIALIZED;

	if ((gpm_handle = ec64sys_socketcall(SYS_SOCKET, &socket)) != -1)
		{
		gpm_state |= GPM_OPEN;
		socket_unix.familiy = AF_UNIX;
		memory_copy(&socket_unix.path, gpm_path, sizeof(gpm_path));
		connect[0] = gpm_handle;
		connect[1] = (d) &socket_unix;
		ec64sys_socketcall(SYS_CONNECT, &connect);
		}
	}



/****************************************************************************
 * gpm_restore **************************************************************
 ****************************************************************************/
void	gpm_restore(
	void)

	{
	if (gpm_state & GPM_OPEN)
		{
		gpm_state &= ~ GPM_OPEN;
		ec64sys_close(gpm_handle);
		}
	gpm_state &= ~ GPM_INITIALIZED;
	}
#endif /* EC64_ENABLE_KDSETMODE */
/******************************************************** ec64@unusedino.de */

