;****************************************************************************
;****************************************************************************
;*
;* string.n
;*
;****************************************************************************
;****************************************************************************





%define STRING_N
%include "string.i"



;****************************************************************************
;* hex lookup table *********************************************************
;****************************************************************************
section .text
ab__hex:		db	"0123456789abcdef"



;****************************************************************************
;* string_print *************************************************************
;****************************************************************************
;* [1]=>  destination string
;* [2]=>  maximal destination length
;* [3]=>  format string
;* [4]+>  pointer to parameters
;* eax=>  length
;****************************************************************************
section .text
string_print:
			push	dword ebx
			push	dword ecx
			push	dword edx
			push	dword ebp
			mov	dword ebx, [esp + 20]
			mov	dword ecx, [esp + 24]
			mov	dword eax, [esp + 28]
			lea	dword ebp, [esp + 32]
			call	string_parse
			pop	dword ebp
			pop	dword edx
			pop	dword ecx
			pop	dword ebx
			ret

ec64io_string_print:	equ	string_print



;****************************************************************************
;* string_length ************************************************************
;****************************************************************************
;* [1]=>  pointer to string
;* <=eax  length
;****************************************************************************
section .text
string_length:
;!!!!!!!!!!!!!
;TODO: use neg
;!!!!!!!!!!!!!
			push	dword ebx
			push	dword ecx
			push	dword edi
			xor	dword ecx, ecx
			mov	dword edi, [esp + 16]
			dec	dword ecx
			cld
			mov	dword ebx, edi
			xor	dword eax, eax
			repne scasb
			mov	dword eax, edi
			sub	dword eax, ebx
			pop	dword edi
			pop	dword ecx
			pop	dword ebx
			dec	dword eax
			ret

ec64io_string_length:	equ	string_length



;****************************************************************************
;* string_compare ***********************************************************
;****************************************************************************
;* [1]=>  pointer to string 1
;* [2]=>  pointer to string 2
;* <=eax  0 strings are equal
;****************************************************************************
section .text
string_compare:
			push	dword ebx
			push	dword ecx
			push	dword edx
			push	dword esi
			push	dword edi
			cld
			xor	dword ecx, ecx
			mov	dword edi, [esp + 24]
			dec	dword ecx
			mov	dword ebx, edi
			xor	dword eax, eax
			repne scasb
			sub	dword edi, ebx
			xor	dword ecx, ecx
			mov	dword edx, edi
			mov	dword edi, [esp + 28]
			dec	dword ecx
			mov	dword ebx, edi
			repne scasb
			sub	dword edi, ebx
			mov	dword ecx, edx
			cmp	dword edx, edi
			jae	.length_ok
			mov	dword ecx, edi
.length_ok:		mov	dword esi, [esp + 24]
			mov	dword edi, [esp + 28]
			repe cmpsb
			test	dword ecx, ecx
			jz	.end
			inc	dword eax
			mov	byte  bl, [esi]
			cmp	byte  bl, [edi]
			ja	.end
			dec	dword eax
			dec	dword eax
.end:			pop	dword edi
			pop	dword esi
			pop	dword edx
			pop	dword ecx
			pop	dword ebx
			ret

ec64io_string_compare:	equ	string_compare



;****************************************************************************
;* string_parse *************************************************************
;****************************************************************************
;* eax=>  source string
;* ebx=>  destination string
;* ecx=>  maximal length of destination string
;* ebp=>  pointer to optional parameters
;* <=eax  destination string length
;****************************************************************************
section .text
string_parse:
			push	dword ebx
			push	dword ecx
			push	dword edx
			push	dword esi
			push	dword ebp
			or	dword ecx, ecx
			jz	.exit
			dec	dword ecx
			jz	.end
			mov	dword esi, eax
.get_byte:		mov	byte  al, [esi]
			inc	dword esi
			or	byte  al, al
			jz	.end
			cmp	byte  al, STRING_FIRST_TOKEN
			jb	.copy_byte
			cmp	byte  al, STRING_LAST_TOKEN
			ja	.skip_token
			sub	byte  al, STRING_FIRST_TOKEN
			and	dword eax, 0ffh
			call	dword [.ad__insert_functions + 4 * eax]
			test	dword eax, eax
			jz	.get_byte
			jmp	.end
.skip_token:		mov	byte  al, '?'
.copy_byte:		mov	byte  [ebx], al
			inc	dword ebx
			dec	dword ecx
			jnz	.get_byte
.end:			xor	byte  al, al
			mov	byte  [ebx], al
			inc	dword ebx
.exit:			pop	dword ebp
			pop	dword esi
			pop	dword edx
			mov	dword eax, ebx
			pop	dword ecx
			pop	dword ebx
			sub	dword eax, ebx
			ret

			;-------------------------
			;insert function addresses
			;-------------------------

			align	4
.ad__insert_functions:	dd	insert_string
			dd	insert_hex8
			dd	insert_hex16
			dd	insert_hex32
			dd	insert_dec8
			dd	insert_dec16
			dd	insert_dec32
			dd	insert_bin8
			dd	insert_bin16
			dd	insert_bin32
			dd	insert_flag8
			dd	insert_flag16
			dd	insert_flag32

			;------------
			;insert a '?'
			;------------

insert_nothing:		mov	byte  al, '?'
			dec	dword ecx
			jb	.end
			mov	byte  [ebx], al
			inc	dword ebx
			xor	dword eax, eax
.end:			ret

			;---------------
			;insert a string
			;---------------

insert_string:		push	dword esi
			xor	dword eax, eax
			mov	dword esi, [ebp]
			add	dword ebp, 4
.copy_byte:		mov	byte  al, [esi]
			inc	dword esi
			test	byte  al, al
			jz	.return
			mov	byte  [ebx], al
			inc	dword ebx
			dec	dword ecx
			jnz	.copy_byte
.return:		pop	dword esi
			ret

			;-------------------------
			;insert a 8 bit hex number
			;-------------------------

insert_hex8:		mov	dword eax, [ebp]
			add	dword ebp, 4
			sub	dword ecx, 2
			jb	.end
			call	string_hex8
			add	dword ebx, 2
			xor	dword eax, eax
			ret
.end:			mov	byte  al, 0ffh
			ret

			;--------------------------
			;insert a 16 bit hex number
			;--------------------------

insert_hex16:		mov	dword eax, [ebp]
			add	dword ebp, 4
			sub	dword ecx, 4
			jb	.end
			call	string_hex16
			add	dword ebx, 4
			xor	dword eax, eax
			ret
.end:			mov	byte  al, 0ffh
			ret

			;--------------------------
			;insert a 32 bit hex number
			;--------------------------

insert_hex32:		mov	dword eax, [ebp]
			add	dword ebp, 4
			sub	dword ecx, 8
			jb	.end
			call	string_hex32
			add	dword ebx, 8
			xor	dword eax, eax
			ret
.end:			mov	byte  al, 0ffh
			ret

			;-----------------------------
			;insert a 8 bit decimal number
			;-----------------------------

insert_dec8:		equ	insert_nothing

			;------------------------------
			;insert a 16 bit decimal number
			;------------------------------

insert_dec16:		equ	insert_nothing

			;------------------------------
			;insert a 32 bit decimal number
			;------------------------------

insert_dec32:		mov	dword eax, [ebp]
			add	dword ebp, 4
			cmp	dword ecx, 10
			jb	.end
			call	string_dec32
			add	dword ebx, eax
			sub	dword ecx, eax
			xor	dword eax, eax
			ret
.end:			mov	byte  al, 0ffh
			ret

			;----------------------------
			;insert a 8 bit binary number
			;----------------------------

insert_bin8:		equ	insert_nothing

			;-----------------------------
			;insert a 16 bit binary number
			;-----------------------------

insert_bin16:		equ	insert_nothing

			;-----------------------------
			;insert a 32 bit binary number
			;-----------------------------

insert_bin32:		equ	insert_nothing

			;-------------------
			;insert a 8 bit flag
			;-------------------

insert_flag8:		mov	dword eax, [ebp]
			add	dword ebp, 4
			sub	dword ecx, 8
			jb	.end
			call	string_flag8
			add	dword ebx, 8
			xor	dword eax, eax
			ret
.end:			mov	byte  al, 0ffh
			ret

			;--------------------
			;insert a 16 bit flag
			;--------------------

insert_flag16:		equ	insert_nothing

			;--------------------
			;insert a 32 bit flag
			;--------------------

insert_flag32:		mov	dword eax, [ebp]
			add	dword ebp, 4
			sub	dword ecx, 32
			jb	.end
			call	string_flag32
			add	dword ebx, 32
			xor	dword eax, eax
			ret
.end:			mov	byte  al, 0ffh
			ret



;****************************************************************************
;* string_hex8 **************************************************************
;****************************************************************************
;* eax=>  number
;* ebx=>  pointer were to place the hex number
;****************************************************************************
section .text
string_hex8:
			push	dword eax
			push	dword ebx
			push	dword ecx
			push	dword edx
			push	dword esi
			mov	dword edx, eax
			mov	byte  cl, 002h
			shl	dword edx, 24
.decode:		rol	dword edx, 4
			mov	dword esi, edx
			and	dword esi, 00fh
			mov	byte  al, [ab__hex + esi]
			mov	byte  [ebx], al
			inc	dword ebx
			dec	byte  cl
			jnz	.decode
			pop	dword esi
			pop	dword edx
			pop	dword ecx
			pop	dword ebx
			pop	dword eax
			ret



;****************************************************************************
;* string_hex16 *************************************************************
;****************************************************************************
;* eax=>  number
;* ebx=>  pointer were to place the hex number
;****************************************************************************
section .text
string_hex16:
			push	dword eax
			push	dword ebx
			push	dword ecx
			push	dword edx
			push	dword esi
			mov	dword edx, eax
			mov	byte  cl, 004h
			shl	dword edx, 16
.decode:		rol	dword edx, 4
			mov	dword esi, edx
			and	dword esi, 00fh
			mov	byte  al, [ab__hex + esi]
			mov	byte  [ebx], al
			inc	dword ebx
			dec	byte  cl
			jnz	.decode
			pop	dword esi
			pop	dword edx
			pop	dword ecx
			pop	dword ebx
			pop	dword eax
			ret



;****************************************************************************
;* string_hex32 *************************************************************
;****************************************************************************
;* eax=>  number
;* ebx=>  pointer were to place the hex number
;****************************************************************************
section .text
string_hex32:
			push	dword eax
			push	dword ebx
			push	dword ecx
			push	dword edx
			push	dword esi
			mov	dword edx, eax
			mov	byte  cl, 008h
.decode:		rol	dword edx, 4
			mov	dword esi, edx
			and	dword esi, 00fh
			mov	byte  al, [ab__hex + esi]
			mov	byte  [ebx], al
			inc	dword ebx
			dec	byte  cl
			jnz	.decode
			pop	dword esi
			pop	dword edx
			pop	dword ecx
			pop	dword ebx
			pop	dword eax
			ret



;****************************************************************************
;* string_dec32 *************************************************************
;****************************************************************************
;* eax=>  number
;* ebx=>  pointer were to place the hex number
;* <=eax  destination string length
;****************************************************************************
section .text
string_dec32:
			push	dword ebx
			push	dword ecx
			push	dword edx
			push	dword esi
			push	dword edi
			mov	dword ecx, 1000000000
			mov	dword esi, 10
			mov	dword edi, esi
.decode:		xor	dword edx, edx
			div	dword ecx
			dec	dword edi
			jz	.decode_1
			test	byte  al, al
			jz	.decode_2
			xor	dword edi, edi
.decode_1:		add	byte  al, '0'
			inc	dword edi
			mov	byte  [ebx], al
			inc	dword ebx
.decode_2:		push	dword edx
			mov	dword eax, ecx
			xor	dword edx, edx
			div	dword esi
			mov	dword ecx, eax
			pop	dword eax
			test	dword ecx, ecx
			jnz	.decode
			mov	dword eax, ebx
			pop	dword edi
			pop	dword esi
			pop	dword edx
			pop	dword ecx
			pop	dword ebx
			sub	dword eax, ebx
			ret



;****************************************************************************
;* string_flag8 *************************************************************
;****************************************************************************
;* eax=>  number
;* ebx=>  pointer were to place the hex number
;****************************************************************************
section .text
string_flag8:
			push	dword eax
			push	dword ebx
			push	dword ecx
			push	dword edx
			mov	dword edx, eax
			mov	byte  cl, 008h
			shl	dword edx, 24
.decode:		rol	dword edx, 1
			mov	byte  al, '.'
			jnc	.decode_1
			mov	byte  al, '*'
.decode_1:		mov	byte  [ebx], al
			inc	dword ebx
			dec	byte  cl
			jnz	.decode
			pop	dword edx
			pop	dword ecx
			pop	dword ebx
			pop	dword eax
			ret



;****************************************************************************
;* string_flag32 ************************************************************
;****************************************************************************
;* eax=>  number
;* ebx=>  pointer were to place the hex number
;****************************************************************************
section .text
string_flag32:
			push	dword eax
			push	dword ebx
			push	dword ecx
			push	dword edx
			mov	dword edx, eax
			mov	byte  cl, 020h
.decode:		rol	dword edx, 1
			mov	byte  al, '.'
			jnc	.decode_1
			mov	byte  al, '*'
.decode_1:		mov	byte  [ebx], al
			inc	dword ebx
			dec	byte  cl
			jnz	.decode
			pop	dword edx
			pop	dword ecx
			pop	dword ebx
			pop	dword eax
			ret
;******************************************************** ec64@unusedino.de *

