;****************************************************************************
;****************************************************************************
;*
;* ec64sys.n
;*
;****************************************************************************
;****************************************************************************





%define EC64SYS_N
%include "ec64sys.i"
%include "ec64io.i"



;****************************************************************************
;* linux syscall numbers ****************************************************
;****************************************************************************
%assign LINUX_SYS_EXIT			1
%assign LINUX_SYS_READ			3
%assign LINUX_SYS_WRITE			4
%assign LINUX_SYS_OPEN			5
%assign LINUX_SYS_CLOSE			6
%assign LINUX_SYS_GETUID		24
%assign LINUX_SYS_GETGID		47
%assign LINUX_SYS_SIGNAL		48
%assign LINUX_SYS_IOCTL			54
%assign LINUX_SYS_FCNTL			55
%assign LINUX_SYS_GETTIMEOFDAY		78
%assign LINUX_SYS_MMAP			90
%assign LINUX_SYS_MUNMAP		91
%assign LINUX_SYS_IOPERM		101
%assign LINUX_SYS_SOCKETCALL		102
%assign LINUX_SYS_SETFSUID		138
%assign LINUX_SYS_SETFSGID		139
%assign LINUX_SYS_SELECT		142
%assign LINUX_SYS_NANOSLEEP		162



;****************************************************************************
;* freebsd syscall numbers **************************************************
;****************************************************************************
%assign FREEBSD_SYS_EXIT		1
%assign FREEBSD_SYS_READ		3
%assign FREEBSD_SYS_WRITE		4



;****************************************************************************
;* struct's *****************************************************************
;****************************************************************************
				struc	tsyscall
				alignb	4
d__syscall_exit:		resd	1
p__syscall_exit:		resd	1
d__syscall_read:		resd	1
p__syscall_read:		resd	1
d__syscall_write:		resd	1
p__syscall_write:		resd	1
d__syscall_open:		resd	1
p__syscall_open:		resd	1
d__syscall_close:		resd	1
p__syscall_close:		resd	1
d__syscall_getuid:		resd	1
p__syscall_getuid:		resd	1
d__syscall_getgid:		resd	1
p__syscall_getgid:		resd	1
d__syscall_signal:		resd	1
p__syscall_signal:		resd	1
d__syscall_ioctl:		resd	1
p__syscall_ioctl:		resd	1
d__syscall_fcntl:		resd	1
p__syscall_fcntl:		resd	1
d__syscall_mmap:		resd	1
p__syscall_mmap:		resd	1
d__syscall_munmap:		resd	1
p__syscall_munmap:		resd	1
d__syscall_ioperm:		resd	1
p__syscall_ioperm:		resd	1
d__syscall_socketcall:		resd	1
p__syscall_socketcall:		resd	1
d__syscall_setfsuid:		resd	1
p__syscall_setfsuid:		resd	1
d__syscall_setfsgid:		resd	1
p__syscall_setfsgid:		resd	1
d__syscall_select:		resd	1
p__syscall_select:		resd	1
d__syscall_time:		resd	1
p__syscall_time:		resd	1
d__syscall_sleep:		resd	1
p__syscall_sleep:		resd	1
				endstruc



;****************************************************************************
;* data *********************************************************************
;****************************************************************************
section .rodata
			align	4
syscall__linux:		istruc	tsyscall
			at	d__syscall_exit,		dd	LINUX_SYS_EXIT
			at	p__syscall_exit,		dd	linux_syscall
			at	d__syscall_read,		dd	LINUX_SYS_READ
			at	p__syscall_read,		dd	linux_syscall
			at	d__syscall_write,		dd	LINUX_SYS_WRITE
			at	p__syscall_write,		dd	linux_syscall
			at	d__syscall_open,		dd	LINUX_SYS_OPEN
			at	p__syscall_open,		dd	linux_syscall
			at	d__syscall_close,		dd	LINUX_SYS_CLOSE
			at	p__syscall_close,		dd	linux_syscall
			at	d__syscall_getuid,		dd	LINUX_SYS_GETUID
			at	p__syscall_getuid,		dd	linux_syscall
			at	d__syscall_getgid,		dd	LINUX_SYS_GETGID
			at	p__syscall_getgid,		dd	linux_syscall
			at	d__syscall_signal,		dd	LINUX_SYS_SIGNAL
			at	p__syscall_signal,		dd	linux_syscall
			at	d__syscall_ioctl,		dd	LINUX_SYS_IOCTL
			at	p__syscall_ioctl,		dd	linux_syscall
			at	d__syscall_fcntl,		dd	LINUX_SYS_FCNTL
			at	p__syscall_fcntl,		dd	linux_syscall
			at	d__syscall_mmap,		dd	LINUX_SYS_MMAP
			at	p__syscall_mmap,		dd	linux_syscall_no_error
			at	d__syscall_munmap,		dd	LINUX_SYS_MUNMAP
			at	p__syscall_munmap,		dd	linux_syscall
			at	d__syscall_ioperm,		dd	LINUX_SYS_IOPERM
			at	p__syscall_ioperm,		dd	linux_syscall
			at	d__syscall_socketcall,		dd	LINUX_SYS_SOCKETCALL
			at	p__syscall_socketcall,		dd	linux_syscall
			at	d__syscall_setfsuid,		dd	LINUX_SYS_SETFSUID
			at	p__syscall_setfsuid,		dd	linux_syscall
			at	d__syscall_setfsgid,		dd	LINUX_SYS_SETFSGID
			at	p__syscall_setfsgid,		dd	linux_syscall
			at	d__syscall_select,		dd	LINUX_SYS_SELECT
			at	p__syscall_select,		dd	linux_syscall
			at	d__syscall_time,		dd	0
			at	p__syscall_time,		dd	linux_time
			at	d__syscall_sleep,		dd	0
			at	p__syscall_sleep,		dd	linux_sleep
			iend

syscall__freebsd:	istruc	tsyscall
			at	d__syscall_exit,		dd	FREEBSD_SYS_EXIT
			at	p__syscall_exit,		dd	freebsd_syscall
			at	d__syscall_read,		dd	FREEBSD_SYS_READ
			at	p__syscall_read,		dd	freebsd_syscall
			at	d__syscall_write,		dd	FREEBSD_SYS_WRITE
			at	p__syscall_write,		dd	freebsd_syscall
			iend

section .data
			align	4
ec64sys_error_number:	dd	0
ec64sys_os_type:	dd	0
p__syscall_table:	dd	0



;****************************************************************************
;* linux_syscall ************************************************************
;****************************************************************************
section .text
linux_syscall:
			pop	dword eax
			push	dword ebx
			push	dword ecx
			push	dword edx
			push	dword esi
			push	dword edi
			push	dword ebp
			mov	dword ebx, [esp + 28]
			mov	dword ecx, [esp + 32]
			mov	dword edx, [esp + 36]
			mov	dword esi, [esp + 40]
			mov	dword edi, [esp + 44]
			int	byte  080h
			test	dword eax, eax
			jns	.no_error
			mov	dword [ec64sys_error_number], eax
			xor	dword eax, eax
			dec	dword eax
.no_error:		pop	dword ebp
			pop	dword edi
			pop	dword esi
			pop	dword edx
			pop	dword ecx
			pop	dword ebx
			ret



;****************************************************************************
;* linux_syscall_no_error ***************************************************
;****************************************************************************
section .text
linux_syscall_no_error:
			pop	dword eax
			push	dword ebx
			push	dword ecx
			push	dword edx
			push	dword esi
			push	dword edi
			push	dword ebp
			mov	dword ebx, [esp + 28]
			mov	dword ecx, [esp + 32]
			mov	dword edx, [esp + 36]
			mov	dword esi, [esp + 40]
			mov	dword edi, [esp + 44]
			int	byte  080h
			pop	dword ebp
			pop	dword edi
			pop	dword esi
			pop	dword edx
			pop	dword ecx
			pop	dword ebx
			ret



;****************************************************************************
;* linux_time ***************************************************************
;****************************************************************************
;* <=eax  microseconds since last call
;****************************************************************************
section .text
linux_time:
			push	dword ebx
			push	dword ecx
			push	dword edx
			mov	dword eax, LINUX_SYS_GETTIMEOFDAY
			mov	dword ebx, .ttimeval__end
			xor	dword ecx, ecx
			int	byte  080h
			test	dword eax, eax
			js	.overflow
			test	byte  [.flag__start_time], NOT8
			jnz	.continue
			mov	byte  [.flag__start_time], 1
.overflow:		xor	dword eax, eax
			dec	dword eax
			jmp	.end
.continue:		mov	dword ebx, [.ttimeval__end + d__timeval_usec]
			mov	dword eax, [.ttimeval__end + d__timeval_sec]
			mov	dword ecx, 1000000
			sub	dword ebx, [.ttimeval__start + d__timeval_usec]
			jnc	.no_underflow
			add	dword ebx, ecx
			stc
.no_underflow:		sbb	dword eax, [.ttimeval__start + d__timeval_sec]
			mul	dword ecx
			add	dword eax, ebx
			test	dword edx, edx
			jnz	.overflow
.end:			mov	dword ebx, [.ttimeval__end + d__timeval_sec]
			mov	dword ecx, [.ttimeval__end + d__timeval_usec]
			mov	dword [.ttimeval__start + d__timeval_sec], ebx
			mov	dword [.ttimeval__start + d__timeval_usec], ecx
			pop	dword edx
			pop	dword ecx
			pop	dword ebx
			ret

section .data
			align	4
.ttimeval__start:	istruc	ttimeval
			iend

.ttimeval__end:		istruc	ttimeval
			iend

.flag__start_time:	db	0



;****************************************************************************
;* linux_sleep **************************************************************
;****************************************************************************
;* [1]=>  microseconds to sleep
;****************************************************************************
section .text
linux_sleep:
%ifdef EC64SYS_ENABLE_NANOSLEEP
			push	dword eax
			push	dword ebx
			push	dword ecx
			push	dword edx
			mov	dword eax, [esp + 20]
			mov	dword ebx, 1000
			mov	dword ecx, 1000000000
			mul	dword ebx
			div	dword ecx
			mov	dword [.ttimespec__sleep + d__timespec_sec], eax
			mov	dword [.ttimespec__sleep + d__timespec_nsec], edx
			mov	dword eax, LINUX_SYS_NANOSLEEP
			mov	dword ebx, .ttimespec__sleep
			xor	dword ecx, ecx
			int	byte  080h
			pop	dword edx
			pop	dword ecx
			pop	dword ebx
			pop	dword eax
			ret

section .data
			align	4
.ttimespec__sleep:	istruc	ttimespec
			iend
%else
			push	dword eax
			push	dword ebx
			push	dword ecx
			push	dword edx
			push	dword esi
			push	dword edi
			mov	dword eax, [esp + 28]
			xor	dword ebx, ebx
			mov	dword [.ttimeval__sleep + d__timeval_usec], eax
			mov	dword [.ttimeval__sleep + d__timeval_sec], ebx
			xor	dword ecx, ecx
			xor	dword edx, edx
			xor	dword esi, esi
			mov	dword edi, .ttimeval__sleep
			mov	dword eax, LINUX_SYS_SELECT
			int	byte  080h
			pop	dword edi
			pop	dword esi
			pop	dword edx
			pop	dword ecx
			pop	dword ebx
			pop	dword eax
			ret

section .data
			align	4
.ttimeval__sleep:	istruc	ttimeval
			iend
%endif



;****************************************************************************
;* freebsd_syscall **********************************************************
;****************************************************************************
section .text
freebsd_syscall:
			pop	dword eax
			int	byte  080h
			jnc	.no_error
			mov	dword [ec64sys_error_number], eax
			xor	dword eax, eax
			dec	dword eax
.no_error:		ret



;****************************************************************************
;* freebsd_syscall_no_error *************************************************
;****************************************************************************
section .text
freebsd_syscall_no_error:
			pop	dword eax
			int	byte  080h
			ret



;****************************************************************************
;* ec64sys_get_version ******************************************************
;****************************************************************************
section .text
ec64sys_get_version:
			mov	dword eax, .text
			ret

.text:			db	"0.2", 0



;****************************************************************************
;* ec64sys_start ************************************************************
;****************************************************************************
%ifnidn LINUX_SYS_WRITE, FREEBSD_SYS_WRITE
%error "syscall numbers differs"
%endif

section .text
ec64sys_start:
			;---------------------------------------------
			;determine the underlying kernel calling style
			;---------------------------------------------

			mov	dword eax, syscall__linux
			mov	dword [p__syscall_table], eax
			mov	dword eax, LINUX_SYS_WRITE
			mov	dword ebx, 1
			mov	dword ecx, ec64sys_start
			xor	dword edx, edx
			push	dword edx
			push	dword ecx
			push	dword 3		;bad filedescriptor for BSD
			push	dword edx
			int	byte  080h
			mov	dword ebx, EC64SYS_OS_LINUX
			test	dword eax, eax
			je	.linux
			mov	dword eax, syscall__freebsd
			mov	dword ebx, EC64SYS_OS_FREEBSD
			mov	dword [p__syscall_table], eax
.linux:			mov	dword [ec64sys_os_type], ebx
			add	dword esp, 16

			;----------------------
			;pass control to ec64io
			;----------------------

			lea	dword ebx, [esp + 4]
			mov	dword eax, [esp]
			sub	dword esp, 32		;dummy arguments
			push	dword ebx
			push	dword eax
			call	ec64io_start
			add	dword esp, 8
			xor	dword eax, eax
			push	dword eax
			jmp	ec64sys_exit



;****************************************************************************
;* ec64sys_exit *************************************************************
;****************************************************************************
section .text
ec64sys_exit:
			mov	dword eax, [p__syscall_table]
			push	dword [eax + d__syscall_exit]
			jmp	dword [eax + p__syscall_exit]



;****************************************************************************
;* ec64sys_read *************************************************************
;****************************************************************************
section .text
ec64sys_read:
			mov	dword eax, [p__syscall_table]
			push	dword [eax + d__syscall_read]
			jmp	dword [eax + p__syscall_read]



;****************************************************************************
;* ec64sys_write ************************************************************
;****************************************************************************
section .text
ec64sys_write:
			mov	dword eax, [p__syscall_table]
			push	dword [eax + d__syscall_write]
			jmp	dword [eax + p__syscall_write]



;****************************************************************************
;* ec64sys_open *************************************************************
;****************************************************************************
section .text
ec64sys_open:
			mov	dword eax, [p__syscall_table]
			push	dword [eax + d__syscall_open]
			jmp	dword [eax + p__syscall_open]



;****************************************************************************
;* ec64sys_close ************************************************************
;****************************************************************************
section .text
ec64sys_close:
			mov	dword eax, [p__syscall_table]
			push	dword [eax + d__syscall_close]
			jmp	dword [eax + p__syscall_close]



;****************************************************************************
;* ec64sys_getuid ***********************************************************
;****************************************************************************
section .text
ec64sys_getuid:
			mov	dword eax, [p__syscall_table]
			push	dword [eax + d__syscall_getuid]
			jmp	dword [eax + p__syscall_getuid]



;****************************************************************************
;* ec64sys_getgid ***********************************************************
;****************************************************************************
section .text
ec64sys_getgid:
			mov	dword eax, [p__syscall_table]
			push	dword [eax + d__syscall_getgid]
			jmp	dword [eax + p__syscall_getgid]



;****************************************************************************
;* ec64sys_signal ***********************************************************
;****************************************************************************
section .text
ec64sys_signal:
			mov	dword eax, [p__syscall_table]
			push	dword [eax + d__syscall_signal]
			jmp	dword [eax + p__syscall_signal]



;****************************************************************************
;* ec64sys_ioctl ************************************************************
;****************************************************************************
section .text
ec64sys_ioctl:
			mov	dword eax, [p__syscall_table]
			push	dword [eax + d__syscall_ioctl]
			jmp	dword [eax + p__syscall_ioctl]



;****************************************************************************
;* ec64sys_fcntl ************************************************************
;****************************************************************************
section .text
ec64sys_fcntl:
			mov	dword eax, [p__syscall_table]
			push	dword [eax + d__syscall_fcntl]
			jmp	dword [eax + p__syscall_fcntl]



;****************************************************************************
;* ec64sys_mmap *************************************************************
;****************************************************************************
section .text
ec64sys_mmap:
			mov	dword eax, [p__syscall_table]
			push	dword [eax + d__syscall_mmap]
			jmp	dword [eax + p__syscall_mmap]



;****************************************************************************
;* ec64sys_munmap ***********************************************************
;****************************************************************************
section .text
ec64sys_munmap:
			mov	dword eax, [p__syscall_table]
			push	dword [eax + d__syscall_munmap]
			jmp	dword [eax + p__syscall_munmap]



;****************************************************************************
;* ec64sys_ioperm ***********************************************************
;****************************************************************************
section .text
ec64sys_ioperm:
			mov	dword eax, [p__syscall_table]
			push	dword [eax + d__syscall_ioperm]
			jmp	dword [eax + p__syscall_ioperm]



;****************************************************************************
;* ec64sys_socketcall *******************************************************
;****************************************************************************
section .text
ec64sys_socketcall:
			mov	dword eax, [p__syscall_table]
			push	dword [eax + d__syscall_socketcall]
			jmp	dword [eax + p__syscall_socketcall]



;****************************************************************************
;* ec64sys_setfsuid *********************************************************
;****************************************************************************
section .text
ec64sys_setfsuid:
			mov	dword eax, [p__syscall_table]
			push	dword [eax + d__syscall_setfsuid]
			jmp	dword [eax + p__syscall_setfsuid]



;****************************************************************************
;* ec64sys_setfsgid *********************************************************
;****************************************************************************
section .text
ec64sys_setfsgid:
			mov	dword eax, [p__syscall_table]
			push	dword [eax + d__syscall_setfsgid]
			jmp	dword [eax + p__syscall_setfsgid]



;****************************************************************************
;* ec64sys_select ***********************************************************
;****************************************************************************
section .text
ec64sys_select:
			mov	dword eax, [p__syscall_table]
			push	dword [eax + d__syscall_select]
			jmp	dword [eax + p__syscall_select]



;****************************************************************************
;* ec64sys_time *************************************************************
;****************************************************************************
;* <=eax  microseconds since last call
;****************************************************************************
section .text
ec64sys_time:
			mov	dword eax, [p__syscall_table]
			jmp	dword [eax + p__syscall_time]



;****************************************************************************
;* ec64sys_sleep ************************************************************
;****************************************************************************
;* [1]=>  microseconds to sleep
;****************************************************************************
section .text
ec64sys_sleep:
			mov	dword eax, [p__syscall_table]
			jmp	dword [eax + p__syscall_sleep]



;****************************************************************************
;* ec64sys_inb **************************************************************
;****************************************************************************
section .text
ec64sys_inb:
			push	dword edx
			xor	dword eax, eax
			mov	dword edx, [esp + 8]
			in	byte  al, dx
			pop	dword edx
			ret



;****************************************************************************
;* ec64sys_inw **************************************************************
;****************************************************************************
section .text
ec64sys_inw:
			push	dword edx
			xor	dword eax, eax
			mov	dword edx, [esp + 8]
			in	word  ax, dx
			pop	dword edx
			ret



;****************************************************************************
;* ec64sys_ind **************************************************************
;****************************************************************************
section .text
ec64sys_ind:
			push	dword edx
			mov	dword edx, [esp + 8]
			in	dword eax, dx
			pop	dword edx
			ret



;****************************************************************************
;* ec64sys_outb *************************************************************
;****************************************************************************
section .text
ec64sys_outb:
			push	dword eax
			push	dword edx
			mov	dword edx, [esp + 12]
			mov	dword eax, [esp + 16]
			out	word  dx, al
			pop	dword edx
			pop	dword eax
			ret



;****************************************************************************
;* ec64sys_outw *************************************************************
;****************************************************************************
section .text
ec64sys_outw:
			push	dword eax
			push	dword edx
			mov	dword edx, [esp + 12]
			mov	dword eax, [esp + 16]
			out	word  dx, ax
			pop	dword edx
			pop	dword eax
			ret



;****************************************************************************
;* ec64sys_outd *************************************************************
;****************************************************************************
section .text
ec64sys_outd:
			push	dword eax
			push	dword edx
			mov	dword edx, [esp + 12]
			mov	dword eax, [esp + 16]
			out	word  dx, eax
			pop	dword edx
			pop	dword eax
			ret
;******************************************************** ec64@unusedino.de *

